var accountURL;
var restoreURL;
//var emailError = '-1';

function loadData() {
	remote = top.remote;
    loadResources(types, resources, 'Backend');
	updateText();
	loadInfo();
	$('#contentBody').show();
}

function loadInfo() {
	var x = remote.XGWBackend_getBackendProperties();
	if(isError(x)) return;
	x = x.result;
	var permanentConnected = x.ConnectionProperty;
	check($('#permanentBackendConnectionCheck'), permanentConnected);
	var connectionStatus = x.ConnectionStatus;
	var label = connectionStatus ? 'backend.connection.true' : 'backend.connection.false';
	$('#connectionStatus').html(getResource(resourceMap, label));
	var initStatus = x.InitializationStatus;
	label = (initStatus == 2) ? 'backend.account.created' : 'backend.account.not.created';
	$('#accountStatus').html(getResource(resourceMap, label));
	if (!connectionStatus || initStatus == 2) {
		$('#content').hide();
	} else {
		$('#content').show();
	}
	//if (connectionStatus && initStatus == 2) {
	//	$('#sms_messages_alarm').text(getRes('messages.alarm'));
	//	$('#sms_messages_warning').text(getRes('messages.warning'));
	//	$('#sms_messages_error').text(getRes('messages.error'));
	//	$('#messagesSettings').show();
	//} else {
	//	$('#messagesSettings').hide();
	//}
	//loadNotification(x);
	accountURL = x.CreateAccountURL;
	restoreURL = x.RestoreAccountURL;
}

//function loadNotification(x) {
//	var sendEmails = x.SendEmails;
//	check($('#emailEnabled'), sendEmails);
//	check($('#emailAlarmEnabled'), x.EmailAlarm);
//	check($('#emailWarningEnabled'), x.EmailWarning);
//	check($('#emailErrorEnabled'), x.EmailError);
//	$('#email').val(x.Email);
//
//	var sendSMS = x.SendSMS;
//	check($('#smsEnabled'), sendSMS);
//	check($('#smsAlarmEnabled'), x.SMSAlarm);
//	check($('#smsWarningEnabled'), x.SMSWarning);
//	check($('#smsErrorEnabled'), x.SMSError);
//	$('#sms').val(x.Number);
//
//	check($('#customerService'), x.SendCustomerService);
//	set_disabled(!sendEmails, ['emailAlarmEnabled','emailWarningEnabled','emailErrorEnabled']);
//	set_disabled(!sendSMS, ['smsAlarmEnabled','smsWarningEnabled','smsErrorEnabled']);
//}

//function setMessageSettings() {
//	var checked = checkEmail($('#email').val(), 'true');
//	if (!checked) {
//		var errorMsg = 'massages.mail.not.valid.' + emailError;
//		top.showInfoDialog(getRes('messages.error'), getRes(errorMsg), 'error');
//		return;
//	}
//	checked = checkMobileNumber($('#sms').val(), 'true');
//	if (!checked) {
//		top.showInfoDialog(getRes('messages.error'), getRes('messages.sms.not.valid'), 'error');
//		return;
//	}
//	var x = remote.XGWBackend_setNotificationConfiguration(
//		$('#sms').val(),
//		isChecked($('#smsEnabled')),
//		isChecked($('#smsAlarmEnabled')),
//		isChecked($('#smsWarningEnabled')),
//		isChecked($('#smsErrorEnabled')),
//		$('#email').val(),
//		isChecked($('#emailEnabled')),
//		isChecked($('#emailAlarmEnabled')),
//		isChecked($('#emailWarningEnabled')),
//		isChecked($('#emailErrorEnabled')),
//		isChecked($('#customerService'))
//	);
//}

function changeConnectionStatus() {
	top.showNotProgressBar(getRes("dialog.wait.message"), "", top.watingMsg, 10000, loadInfo);
	var checked = isChecked($('#permanentBackendConnectionCheck'));
	remote.XGWBackend_setBackendPermanentConnection(checked);
}

function createAccount() {
	window.open(accountURL);
}

function restoreAccount() {
	window.open(restoreURL);
}

//function sendTestEmail() {
//	var checked = checkEmail($('#email').val(), 'true');
//	if (!checked) {
//		var errorMsg = 'massages.mail.not.valid.' + emailError;
//		top.showInfoDialog(getRes('messages.error'), getRes(errorMsg), 'error');
//		return;
//	} else {
//		var x = remote.XGWBackend_sendTestEmail($('#email').val());
//	}
//}

//function sendTestSMS() {
//	var checked = checkMobileNumber($('#sms').val(), 'true');
//	if (!checked) {
//		top.showInfoDialog(getRes('messages.error'), getRes('messages.sms.not.valid'), 'error');
//		return;
//	} else {
//		var x = remote.XGWBackend_sendTestSMS($('#sms').val());
//	}
//}

//function set_disabled(state, ids_array) {
//  for(i = 0; i < ids_array.length; i++){
//    var name = ids_array[i];
//    var element = document.getElementById(name);
//    if( element ) {
//  	  element.disabled = state;
//  	}
//  }
//}

/*
function checkMobileNumber(mobile_number, isChecked) {  
  if(!isChecked && mobile_number.length == 0) {
     return true; 
  } else {
    if(mobile_number.length == 0)  return false; 
  }
  var permitted_char_codes = new Array();
  permitted_char_codes[0] = " ".charCodeAt(0);
  permitted_char_codes[1] = "(".charCodeAt(0);
  permitted_char_codes[2] = ")".charCodeAt(0);
  permitted_char_codes[3] = "+".charCodeAt(0);
  permitted_char_codes[4] = "-".charCodeAt(0);
  permitted_char_codes[5] = "/".charCodeAt(0);
  for(var j = 0; j < mobile_number.length; j++){
    var c = mobile_number.charCodeAt(j) ; 
    if (c <= 47 || c >=58) {
		var isPermitted = false;
		for(k = 0; k < permitted_char_codes.length; k++) {
		  if(c == permitted_char_codes[k])	isPermitted = true;
		}
		if(!isPermitted) return false;	
	}
  }
  return true; 
}

function checkEmail(emailStr, isChecked) {
  emailError = '-1';
  var checkTLD=1;
  var knownDomsPat=/^(com|net|org|eu|edu|int|mil|gov|arpa|biz|aero|name|coop|info|pro|museum)$/;
  var emailPat=/^(.+)@(.+)$/;
  var specialChars="\\(\\)><@,;:\\\\\\\"\\.\\[\\]";
  var validChars="\[^\\s" + specialChars + "\]";
  var quotedUser="(\"[^\"]*\")";
  var ipDomainPat=/^\[(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})\]$/;
  var atom=validChars + '+';
  var word="(" + atom + "|" + quotedUser + ")";
  var userPat=new RegExp("^" + word + "(\\." + word + ")*$");
  var domainPat=new RegExp("^" + atom + "(\\." + atom +")*$");
  var matchArray=emailStr.match(emailPat);
  if(emailStr.length == 0 && !isChecked) {
    return true; 
  }
  if (matchArray==null) {
	  emailError = '0';
      return false;
  }
  var user=matchArray[1];
  var domain=matchArray[2];
  for (i=0; i<user.length; i++) {
    if (user.charCodeAt(i)>127) {
		emailError = '1';
      return false;
    }
  }
  for (i=0; i<domain.length; i++) {
    if (domain.charCodeAt(i)>127) {
		 emailError = '2';
      return false;
    }
  }
  if (user.match(userPat)==null) {
	  emailError = '3';
    return false;
  }
  var IPArray=domain.match(ipDomainPat);
  if (IPArray!=null) {
    for (var i=1;i<=4;i++) {
      if (IPArray[i]>255) {
		  emailError = '4';
        return false;
     }
  }
  return true;
} 
  var atomPat=new RegExp("^" + atom + "$");
  var domArr=domain.split(".");
  var len=domArr.length;
  for (i=0;i<len;i++) {
    if (domArr[i].search(atomPat)==-1) {
		emailError = '5';
      return false;
    }
  }
  if (checkTLD && domArr[domArr.length-1].length!=2 && domArr[domArr.length-1].search(knownDomsPat)==-1) {
	  emailError = '6';
    return false;
  }
  if (len<2) {
	  emailError = '7';
    return false;
  }
  return true;
}
*/