// Vars for progress bar
var progValue=0;
var timer;
var tick = 1000;
var finalWait = 5000;
var title;
var progressMessage;
var finishMessage;
var showPercents=true;
// End
// Confirmation Dialog
var callback;
var cancelCallback;
var wizardActive=false;
// End of confirmation dialog;

function showConfirmationDialog(titleParam, prgMessage, call, cancelCall) {
  callback=call;
  cancelCallback = cancelCall;
  title = titleParam;
  progressMessage = prgMessage;

  var label = top.document.getElementById("confirmLabel");
  label.innerHTML = progressMessage;

  label = top.document.getElementById("confirmTitle");
  label.innerHTML=title;
  var contentLayer = top.document.getElementById("modalDialogPanel");
  var dialogPanel = top.document.getElementById("modalDialogPanel");   
  var dialogFrame = top.document.getElementById("confirmFrame");
  dialogPanel.style.display="block";
  dialogFrame.style.display="block";
  if (contentLayer && contentLayer != null) {
    contentLayer.style.display="block";
  }
}

function okPressed() {
  closeConfirmDialog();
  if (callback) {
    return callback();
  }
}

function cancelPressed() {
  closeConfirmDialog();
  if (cancelCallback) {
    return cancelCallback();
  }
}

function closeConfirmDialog() {
  var contentLayer = top.document.getElementById("modalDialogPanel");
  var dialogPanel = top.document.getElementById("modalDialogPanel");
  var dialogFrame = top.document.getElementById("confirmFrame");
  
  dialogPanel.style.display="none";
  dialogFrame.style.display="none";
  if (contentLayer && contentLayer != null) {
    contentLayer.style.display="none";
  }
}

function showProgressBar(titleParam, prgMessage, finMessage, timeout, finWait, showPerc, callbackFunc) {
  progValue = 0;
  title = titleParam;
  progressMessage = prgMessage;
  finishMessage = finMessage;
  showPercents=showPerc;
  callback = callbackFunc ? callbackFunc : null;

  if (!finishMessage) {
    finishMessage = prgMessage;
  }
  if (timeout) {
    tick = timeout;
  } else {
    tick = 1000;
  }
  if (finWait) {
    finalWait = finWait;
  } else {
    finishWait = 5000;
  }
  setDialogVisible(true);
}

function showNotProgressBar(titleParam, prgMessage, finMessage, finWait, callbackFunc) {
  title = titleParam;
  progressMessage = prgMessage;
  finishMessage = finMessage;
  if (finWait) {
    finalWait = finWait;
  } else {
    finishWait = 5000;
  }
  callback = callbackFunc ? callbackFunc : null;
  setNotProgressDialogVisible(true);
}

function showInfoDialog(titleParam, prgMessage, infoType, call, btnText) {
  callback = call;
  title = titleParam;
  progressMessage = prgMessage;
  
  
  var label = top.document.getElementById("infoType");
  if (infoType) {
    if (infoType == "error") {
      label.src = "img/p_critical.png";
	} else if (infoType == "warning") {
      label.src = "img/p_warning.png";
	} else if (infoType == "info") {
      label.src = "img/p_info.png";
	} else {
      label.src = "img/p_critical.png";
	}
  } else {
    label.src = "img/p_default.png";
  }

  if (btnText) {
	$('#dialog_info_close').text(btnText);
  } else {
	$('#dialog_info_close').text(getRes('dialog.info.close'));		
  }

  label = top.document.getElementById("infoLabel1");
  label.innerHTML = progressMessage;

  label = top.document.getElementById("infoTitle");
  label.innerHTML=title;

  showModal($('#infoFrame'));
//  var contentLayer = top.document.getElementById("modalDialogPanel");
//  var dialogPanel = document.getElementById("modalDialogPanel");
//  var dialogFrame = document.getElementById("infoFrame");
//  dialogPanel.style.display="block";
//  dialogFrame.style.display="block";
//  if (contentLayer && contentLayer != null) {
//    contentLayer.style.display="block";
//  }
}

function loginPerformed() {
  var userName;
  var password;
  var el;

  el = top.document.getElementById("userName");
  userName = el.value;

  el = top.document.getElementById("password");
  password = el.value;

  var contentLayer = top.document.getElementById("modalDialogPanel");
  var dialogPanel = top.document.getElementById("modalDialogPanel");
  var dialogFrame = top.document.getElementById("loginFrame");
  
  dialogPanel.style.display="none";
  dialogFrame.style.display="none";
  if (contentLayer && contentLayer != null) {
    contentLayer.style.display="none";
  }

  //if (userName != "xgw2000" || password != "xgw2000") {
  if(remote.XGWLogin_login(userName, password).error){
	  showInfoDialog(getRes('login.title'), getRes('login.error'), "error", function () {showLoginDialog();});
  }else{
	  if(!top.remote.XGWDeviceAdmin_isInitialized().result){
		  showWizzardWelcome();
	  }else{
		  initApplications(getApplications());
		  setFirstPage();
	  }
  }
}


function showWizzardWelcome(){
	wizardActive = true;
	$('#wContent').load('w_welcome.html  #wContent', w_updateText);
	showModal($('#wizzardFrame'));
}

function showWizzardLocal(){
	  $('#wContent').load('w_locale.html  #wContent', loadWizzardLocal);
}

var selectedLanguage;
var selectedCountry;

function loadWizzardLocal(){
	w_updateText();
    var x = remote.XGWLocale_getLocale();
    //if(isError(x)) return;
    var local = x.result;
    
    var c = $('#country');
    //var x = remote.XGWLocale_getCountries().result;
	c.html(keyValueListAsOptions(local.Countries));
	selectedCountry = local.Country; 
	c.val(selectedCountry);

    var l = $('#language');
    l.html(keyValueListAsOptions(local.Languages));
    selectedLanguage = local.Language;
    l.val(selectedLanguage);
}

function nextWizzardLocal(){
	var curCountry = $('#country').val(); 
	var curLang = $('#language').val();
	if(selectedCountry != curCountry || selectedLanguage != curLang){
		clearResourceCache(); 
		remote.XGWLocale_setLocale(curCountry, curLang);
	}
	showWizzardApp1();
}

function showWizzardApp1(){
	  $('#wContent').load('w_appliance.html  #wContent', w_updateText);
	  showModal($('#wizzardFrame'));
}

function appliancesFinished() {
	var x = remote.XGWLocale_isAdvancedServicesAllowed();
	if (x.result) {
		var y = remote.XGWLocale_isRWERelease();
		if (y.result) {
			showNetworkPage();
		} else {
			var z = remote.XGWLocale_isInfoServiceAvailable();
			if (z.result) {
				showWizzardInfoServActivation();
			} else {
				showWizzardSmartGridRegistration();
			}
		}
	} else {
		showNetworkPage();
	}
}

function nextWizzardApp(){
    var isAdded = $('#ready').is(':checked');
    if(isAdded){
		var x = remote.XGWLocale_isAdvancedServicesAllowed();
		if (x.result) {
			var y = remote.XGWLocale_isRWERelease();
			if (y.result) {
				showNetworkPage();
			} else {
				var z = remote.XGWLocale_isInfoServiceAvailable();
				if (z.result) {
					showWizzardInfoServActivation();
				} else {
					showWizzardSmartGridRegistration();
				}
			}
		} else {
			showNetworkPage();
		}
    } else {
		$('#app1').hide();
		$('#app2').show();
    	
    	var isInitial = $('#initial').is(':checked');
    	var wRes = getWizzardRes();
		$('#initial_wizard_button_next1').html(getResource(wRes, 'initial.wizard.button.next'));
    	$('#waitTitle').text(getRes('dialog.wait.message'));
		finishWait = 0;
    	if (isInitial) {
    		$('#initial_wizard_button_next1').unbind('click').click(showWizzardApp2);
    		tick = 1800;
			finishMessage = getResource(wRes, 'create.house.address.success');
			showPercents = false;
    		$('#ehsOp').html(getResource(wRes, 'initial.wizard.appliances.initial'));
            remote.XGWDeviceAdmin_initialInstallation();	
    	
    	} else {
    		$('#initial_wizard_button_next1').unbind('click').click(appliancesFinished);
    		tick = 2400;
			showPercents = false;
			finishMessage = getResource(wRes, 'acquisition.ha.modem.success');
    		$('#ehsOp').html(getResource(wRes, 'initial.wizard.appliances.sign'));
            remote.XGWDeviceAdmin_signOnToMiele();	
    	}
    	
      w_updateText();
	  progValue = 0;
	  finalWait = 0;
	  callback = isInitial ? showWizzardApp2 : finishWizzardApp;
	  timedCount("w_prog_bar", "loadedLabel1", "ehsOp", "waitTitle");  
    }
  }

function finishWizzardApp(){
	$("#initial_wizard_button_next1").prop('disabled', null);
}

var distTimer;

function showWizzardApp2(){
	$('#wContent').load('w_appliance_dist_ha.html  #wContent', w_updateText);
	var x = remote.XGWDeviceAdmin_simpleSignOnAppliance();
	distTimer = setTimeout('simpleSignOn();', 30000);
	showModal($('#wizzardFrame'));
}

function simpleSignOn() {
    remote.XGWDeviceAdmin_simpleSignOnAppliance();
	distTimer = setTimeout('simpleSignOn();', 30000);
}

function distHouseAddress(){
	clearTimeout(distTimer);
	$('#app1').hide();
	$('#app2').show();
    	
	var wRes = getWizzardRes();
	$('#initial_wizard_button_next1').html(getResource(wRes, 'initial.wizard.button.next'));
	$('#waitTitle').text(getRes('dialog.wait.message'));
	finishWait = 0;
	tick = 1200;
	finishMessage = getResource(wRes, 'distribute.house.address.initial.wizard');
	showPercents = false;
	$('#ehsOp').html(getResource(wRes, 'ehs.progress.dialog.title'));
    remote.XGWDeviceAdmin_signOnAppliance();
	
    w_updateText();
	progValue = 0;
	callback = finishWizzardApp;
	timedCount("w_prog_bar", "loadedLabel1", "ehsOp", "waitTitle");  
}


function showWizzardInfoServActivation(){
	  $('#wContent').load('w_infoservice.html  #wContent', w_updateText);
	  showModal($('#wizzardFrame'));
}


function activateInfoService(){
	var isActivate = $('#now').is(':checked');
	if(isActivate){
		remote.XGWInfoService_activate();
		showWizzardInfoServRegistration();
	} else {
		remote.XGWInfoService_deactivate();
		showWizzardSmartGridRegistration();
	}

}

function showWizzardInfoServRegistration(){
  $('#wContent').load('w_registration.html  #wContent', w_updateText);
  showModal($('#wizzardFrame'));
}

function registrationInfoService(){
	var isReg = $('#now').is(':checked');
	if(isReg){
		var x = remote.XGWInfoService_getRegistrationURL();
		if(!x.error){
			window.open(x.result);
		}	
	}
	showWizzardSmartGridRegistration();	
}

function showWizzardSmartGridRegistration(){
  $('#wContent').load('w_smartgrid.html  #wContent', w_updateText);
  showModal($('#wizzardFrame'));
}

function activateSmartGrid(){
	var isReg = $('#now').is(':checked');
	remote.XGWSmartGrid_setSmartGridActive(isReg);
	showNetworkPage();
}

function showNetworkPage(){
	$('#wContent').load('w_network.html  #wContent', getNetworkStatus);
}

function getNetworkStatus(){
	w_updateText();
	var x = remote.XGWNetwork_getNetworkStatus();
	if(isError(x)) return;
	var info = x.result;

	var returnValue = '<table class="content" style="width: 80%;">';
	for (var i in info) {
		var map = info[i];
		$.each(map, function(key, value){
			var row = '<tr><td align="left" ">' + key;
			row += '</td><td align="left">' + value + '</td></tr>';
			returnValue += row;
		});
	}

	returnValue += '</table>';
	$('#netSettings').html(returnValue);
}

function showWizzardFinishPage(){
	wizardActive=false;
	$('#wContent').load('w_finish.html  #wContent', w_updateText);
}

function setInitialized() {
//	isInitialized = true;
	$('#wizzardFrame').hide();
	$('#modalDialogPanel').hide();
	
//	loginPerformed();
	remote.XGWDeviceAdmin_setInitialized(true);
//	top.location = top.location;
	
   top.cache = null;
   loadResources(types, resources, "GWAdmin");
   startGWAdmin();
//   initApplications(getApplications());
//   setFirstPage();

}


function getWizzardRes(){
	return getResources(types, w_resources, "GWWizzard");
}

function w_updateText(){
	updateText(getWizzardRes());
}

function showLoginDialog() {
  cleanPage(true);	
  
	$('#wizzardFrame').hide();
	$('#modalDialogPanel').hide();

   var label = $('#userName'); 
   label.val('');
   label.unbind('keypress').keypress(function(e){
							if(e.keyCode == 13){ 
								$('#password').focus().select();
    						} 	
						   });
  
   var label = $('#password'); 
   label.val('');
   label.unbind('keypress').keypress(function(e){
							if(e.keyCode == 13){ 
								$('#login').click();
    						} 	
						   });

   showModal($('#loginFrame'));
}

function showModal(dialog){
   $('#modalDialogPanel').show();	
   dialog.show();
}


function setNotProgressDialogVisible(value) {
//  var contentLayer = top.document.getElementById("modalDialogPanel");
	var dialogPanel = top.document.getElementById("modalDialogPanel");
	var dialogFrame = top.document.getElementById("modalDialogNotProgress");
	if (value) {
		dialogPanel.style.display="block";
		dialogFrame.style.display="block";
//		if (contentLayer && contentLayer != null) {
//		  contentLayer.style.display="block";
//		}
		var label = top.document.getElementById("notProgressTitle");
        label.innerHTML=title;
		notProgressTimedCount();
	} else {
		dialogPanel.style.display="none";
		dialogFrame.style.display="none";
//		if (contentLayer && contentLayer != null) {
//		  contentLayer.style.display="none";
//	}
  }
}

function setDialogVisible(value) {
  //var contentLayer = top.document.getElementById("modalDialogPanel");
	var dialogPanel = top.document.getElementById("modalDialogPanel");
	var dialogFrame = top.document.getElementById("modalDialogFrame");
	if (value) {
		dialogPanel.style.display="block";
		dialogFrame.style.display="block";
//		if (contentLayer && contentLayer != null) {
//		  contentLayer.style.display="block";
//		}
		var label = top.document.getElementById("dialogTitle");
        label.innerHTML=title;
		timedCount("prog_bar", "loadedLabel");
	} else {
		dialogPanel.style.display="none";
		dialogFrame.style.display="none";
	}
}

function closeInfoDialog() {
  var contentLayer = top.document.getElementById("modalDialogPanel");
  var dialogPanel = top.document.getElementById("modalDialogPanel");
  var dialogFrame = top.document.getElementById("infoFrame");
  
  dialogPanel.style.display="none";
  dialogFrame.style.display="none";
  if (contentLayer && contentLayer != null) {
    contentLayer.style.display="none";
  }

  if (callback) {
    return callback();
  }
}

function notProgressTimedCount() {
  var label = top.document.getElementById("notProgressLabel1");
  label.innerHTML = progressMessage;
  label = top.document.getElementById("notProgressLabel2");
  
  if (finishMessage) {
    label.innerHTML = finishMessage;
  } else {
    label.innerHTML = "&nbsp;";
  }
  if (finalWait > 0) {
    timer = setTimeout("notProgressFinish()", finalWait);
  }
}

function notProgressFinish() {
  clearTimeout(timer);
  setNotProgressDialogVisible(false);
  if(callback) callback();
}

function timedCount(progressId, componentId, label1Id, label2Id) {
  setLoaded(progressId, componentId, progValue, progressMessage);
  progValue = progValue + 1;
  if (progValue < 102) {
    timer = setTimeout("timedCount('" + progressId + "', '" + componentId + "', '" + label1Id + "', '" + label2Id + "')", tick);
  } else {
    $("#" + progressId).hide();
	if (label1Id) {
		$("#" + label1Id).hide();
	}
	if (label2Id) {
		$("#" + label2Id).hide();
	}

    var label = $("#" + componentId);
    label.html(finishMessage);
	label.show();
//    var table = $("#"+progressId+" #progress");//top.document.getElementById("progress");
//    var cell = table.rows[0].cells[0];
//    cell.style.width = "100%";

    //$("#"+progressId+" #progress td:eq(0)").css("width",  "100%");
	progValue = 1000;
	if(finalWait > 0){
		timer = setTimeout("finish()", finalWait);
	}else{
		finish();
	}	
  }
}

function finish() {
  clearTimeout(timer);
  if (!wizardActive) {
	  setDialogVisible(false);
  }

  progValue = 0;
  if(callback) callback();
}

function initialLoadModalDialog() {
  progValue = 0;
  var dialogPanel = top.document.getElementById("modalDialogPanel");
  var dialogFrame = top.document.getElementById("modalDialogFrame");
  var dialogNotProgress = top.document.getElementById("modalDialogNotProgress");
  var infoFrame = top.document.getElementById("infoFrame");
  var confirmFrame = top.document.getElementById("confirmFrame");
  var loginFrame = top.document.getElementById("loginFrame");

  dialogPanel.style.display="none";
  dialogFrame.style.display="none";
  dialogNotProgress.style.display="none";
  infoFrame.style.display="none";
  confirmFrame.style.display="none";
  loginFrame.style.display="none";
  $('#wizzardFrame').hide();
}

function setLoaded(progressId, componentId, value, text) {
  //var progress_bar = $("#"+progressId);//top.document.getElementById("prog_bar");
  var progress_bar = top.document.getElementById(progressId);
  progress_bar.style.display="block";
  var label = $('#' + componentId);
  if (showPercents && showPercents == true) {
    label.html(text + ' ' + value + "%");
  } else {
    label.html(text);
  }
  //var table = top.document.getElementById("progress");
  //var cell = table.rows[0].cells[0];
  //cell.style.width = value + "%";
  
  $("#"+progressId+" #progress td:eq(0)").css("width", value + "%");
}


