function initMiscPage() {
    //init RPC
	//remote = jQuery.JR(rpcURI);
	remote = top.remote;
    var x = remote.XGWMiscSettings_getMiscSettings();
    if(!isError(x, 'XGWMiscSettings_getMiscSettings')) miscSettings = x.result;
    loadResources(types, resources, "Misc");
}


function startMiscPage() {
	if(miscSettings) {
	    initData();
	    $('#pageContent').show();
	    if(!top.isWindows) {
	      $('#auto_restart_check').show();
	      $('#gateway_mngt').show();
	    }    
    }
}

function initData() {
	updateText();
	if(miscSettings){
		check($('#login'), miscSettings.Login);
		check($('#fullInfo'), miscSettings.FullInfo);
		check($('#notification'), miscSettings.Notification);
		check($('#upnp'), miscSettings.UPnP);
		check($('#reboot'), miscSettings.Reboot);
	}
}

function applyMiscSettings() {
	var map = {
		Login : isChecked($('#login')),
		FullInfo : isChecked($('#fullInfo')),	
		Notification : isChecked($('#notification')),	
		UPnP : isChecked($('#upnp')),	
		Reboot : isChecked($('#reboot'))	
	};
	return remote.XGWMiscSettings_setMiscSettings(map);
}

function changePassword(pwd, pwdRe) {
	if(pwd.val().length < 7) {
		top.showInfoDialog(getResource(resourceMap,'pwd.title'), getResource(resourceMap, 'pwd.length.incorrect'), 'error');
	}else{
		if(pwd.val() == pwdRe.val()){
			top.showConfirmationDialog(getResource(resourceMap,'pwd.title'), getResource(resourceMap, 'pwd.confirm.message'), isError(remote.XGWLogin_setPassword(pwd.val())));
		}else {
			top.showInfoDialog(getResource(resourceMap,'pwd.title'), getResource(resourceMap, 'pwd.cannont.set.values'), 'error');
		}
	}	
}

function reboot(){
	top.showConfirmationDialog(getResource(resourceMap,'configuration.restart.button'), getResource(resourceMap, 'configuration.restart.message'), restart);
} 

function reset(){
	top.showConfirmationDialog(getResource(resourceMap,'configuration.reset.button'), getResource(resourceMap, 'configuration.reset.message'), resetPerformed);
}

function resetPerformed(){
	top.showNotProgressBar("", "", getResource(resourceMap,'configuration.dialog.reboot'), 120 * 1000, function() {reloadPage();});
	isError(remote.XGWMiscSettings_resetGateway());
}

function restart(){
	top.showNotProgressBar("", "", getResource(resourceMap,'configuration.dialog.reboot'), 45 * 1000 * 2, function() {reloadPage();});
	isError(remote.XGWMiscSettings_restartGateway());
}
function reloadPage() {
	top.location = top.location;
}