#!/bin/sh
cd /static
echo "LED1=01,01,0050" > /dev/bsh_ledd_w
echo "LED2=01,01,0050" > /dev/bsh_ledd_w
echo "LED3=01,01,0050" > /dev/bsh_ledd_w

killall -9 j9
killall -9 mbsa
killall -9 inet_check.sh
killall -9 ntpscript.sh
rm -rf /static/server/*
sleep 3
killall -9 mbsa
sleep 3
rm -rf /opt/mbsa
rm -rf /var/ehs.log
#sync filesystem
/bin/sync
df
mkdir /tmp/dynamic
cp /dynamic/init /tmp/dynamic/
cp /dynamic/storage/country /tmp/dynamic/
mkdir /tmp/smartgrid
cp /dynamic/smartgrid/* /tmp/smartgrid/
mkdir /tmp/infoservice
cp /dynamic/infoservice/* /tmp/infoservice/
cp /dynamic/gw_id /tmp/

rm -rf /dynamic/*

if [ -e /tmp/version ] 
	then
		cp /etc/network_configuration /tmp/network_configuration
fi

df
#sync filesystem
/bin/sync
df
#upload the release
IVEHOME="/static/jvm"
export LD_LIBRARY_PATH="/usr/local/lib:/static/jvm/bin:$LD_LIBRARY_PATH"
/static/jvm/bin/j9 -jcl:max -noverify -Xgcpolicy:optavgpause -Xgc:stringconstantGC -Xint -Xmca8K -Xmco8K -Xmns128K -Xmos512K -Xmoi128k -Xmx15m -Xbootclasspath:/static/jvm/lib/jclMax/classes.zip -cp . ReleaseUnzipper /tmp/mbs.zip /
rm -rf /tmp/mbs.zip

/bin/sync
df

rm -rf /etc/factory/first
mkdir /dynamic
cp /tmp/gw_id /dynamic

cp /tmp/dynamic/init /dynamic
mkdir /dynamic/storage
cp /tmp/dynamic/country /dynamic/storage/country
mkdir /dynamic/smartgrid
mkdir /dynamic/infoservice
cp /tmp/smartgrid/* /dynamic/smartgrid/
cp /tmp/infoservice/* /dynamic/infoservice/

if [ -e /tmp/version ] 
	then
		cp /tmp/network_configuration /etc/network_configuration
fi

#sync filesystem
/bin/sync
chmod 777 /etc/rc
chmod 777 /etc/init.d/leds
chmod 777 /etc/init.d/network
chmod 777 /etc/init.d/ttys
chmod 777 /etc/init.d/udhcpc
chmod 777 /etc/init.d/xgw2000
chmod 777 /usr/share/udhcpc/udhcpc-oem.deconfig
chmod 777 /sbin/restart
#sync filesystem
/bin/sync
sleep 10

/sbin/restart
exit 0
