#!/bin/sh

while [ 1 ];
do
	PROPSFILE=/etc/network_configuration
	MACFILE=/etc/macaddr
	source $PROPSFILE
	source $MACFILE
	NET=`dmesg | tail -n 1`
	NET1=`echo $NET | grep down | cut -d\  -f3`
	echo "NET1 is |"$NET1"|"
	if [ "$NET1" != "down" ]
		then
			DEF_GW=`/sbin/route | grep default | cut -d\  -f10`
			echo $DEF_GW
			RES=`ping -c 1 $DEF_GW | grep received | cut -d, -f2`
			echo $RES
			if [ "x$RES" != "x 1 packets received" ]
				then
					if [ ! -e /etc/factory/first ]
						then
							echo "Stopping the LED for the LAN"
							echo "LED1=00,01,0050" > /dev/bsh_ledd_w
					fi

				else
					echo "The Gateway is responding to the ping command..."
			fi

			if [ "x$DHCP" = "x1" ] 
				then
					if [ "x$RES" != "x 1 packets received" ]
						then
							ifconfig eth0 down
							ifconfig eth0 hw ether $MAC_ADDRESS
							ifconfig eth0 up
							echo "DHCP is enabled ..."
							/etc/init.d/udhcpc restart

							ifconfig eth0:1 hw ether $MAC_ADDRESS
							#Removed on 15.01.2008
							#ifconfig eth0:1 $MAN_CONF_IP netmask $MAN_CONF_MASK up
							#ifconfig eth0:1 up

							cat /etc/hosts > /tmp/hosts.new
							#echo -e "$MAN_CONF_IP\t$HOST" >> /tmp/hosts.new

							NEW_IP=`ifconfig eth0 | grep inet | cut -d:  -f2 | cut -d\  -f1`

							echo -e "$NEW_IP\t$HOST" >> /tmp/hosts.new
							mv /tmp/hosts.new /etc/hosts

						else
							echo "The Gateway is responding to the ping command..."

					fi
			fi
			echo "0" > /tmp/check
		else
			DEF_GW=`/sbin/route | grep default | cut -d\  -f10`
			echo $DEF_GW
			RES=`ping -c 1 $DEF_GW | grep received | cut -d, -f2`
			echo $RES
			if [ "x$RES" != "x 1 packets received" ]
				then
					if [ ! -e /etc/factory/first ]
						then
							echo "Stopping the LED for the LAN"
							echo "LED1=00,01,0050" > /dev/bsh_ledd_w
					fi

				else
					echo "The Gateway is responding to the ping command..."
					echo "0" > /tmp/check

			fi
	fi

	sleep 10
done
exit 0
