#!/bin/sh

FLAG_DEST=/tmp/inet
INET=/etc/inet
IP_INFO=/tmp/ip

while [ 1 ];
do
	NEW_IP=`ifconfig eth0 | grep inet | cut -d:  -f2 | cut -d\  -f1`
	NEW_MASK=`ifconfig eth0 | grep inet | cut -d:  -f4 | cut -d\  -f1`
	DEF_GW=`/sbin/route | grep default | cut -d\  -f10`
	echo "IP="$NEW_IP > $IP_INFO
	echo "MASK="$NEW_MASK >> $IP_INFO
	echo "GW="$DEF_GW >> $IP_INFO

	source $INET
	RES=`/usr/bin/nslookup $INET_ADDR $DNS 2>&1| grep resolve`
	if [ "x$RES" = "x" ];
	then
		echo "Internet connection ON ... "
		touch $FLAG_DEST
	else
		echo "Internet connection OFF ... "
		rm -f $FLAG_DEST
	fi

	sleep $TIME_OUT
done
