#!/bin/sh

export COMMANDS_FILE=/tmp/commandsfile
export LAST_LINE
export NEW_LINE 
export TIME_OUT=5
export TIMES=0

echo 'ntpdate pool.ntp.org' > $COMMANDS_FILE
chmod 777 /static/inet_check.sh
chmod 777 /static/gw_check.sh
chmod 777 /static/ntpcheck.sh
chmod 777 /static/update.sh
chmod 777 /static/userreset.sh

/static/inet_check.sh &
/static/gw_check.sh &

while [ 1 ] 
do
	LAST_LINE=""
	while test -s $COMMANDS_FILE
	do
		# read first line
		NEW_LINE=`sed -n -e '1p' $COMMANDS_FILE`
		
		# remove first line
		sed -n -e '1d' $COMMANDS_FILE > '$COMMANDS_FILE'.new
		mv '$COMMANDS_FILE'.new $COMMANDS_FILE
		
		# check if line is empty
		if test -z "$NEW_LINE"
		then
			continue
		fi
		
		# check if line is same as previous
		if [ "$LAST_LINE" != "$NEW_LINE" ]
		then
			# execute command
			$NEW_LINE
			
			LAST_LINE='$NEW_LINE'
		fi
		
	done

	sleep $TIME_OUT
	
done

