var	friendly_name; 
var	room_name;
var	room_id; 
var	room_level; 
var	tech_type; 
var	fab_num; 
var	distTimer;

function initEHSPage(){
	remote = top.remote;
	loadResources(types, resources, 'Appliances');
}


function startEHSPage(){
    $('#ehsbodytable').hide();

	var x = remote.multi(
						  'XGWDeviceAdmin_getDeviceList'
//						  ,'XGWDeviceAdmin_isInitialized'
						  
						);
	
	if(isError(x[0])) retrun;
	var devRef = x[0].result; 
//	if(isError(x[1])) retrun;
//	isOnline = x[1].result;
	
//	if(isOnline){
	   //showInitializedLinks();
       if(loadDevRef(devRef)){
			$('#ehsbodytable').show();
		}                    
//	}else{
//		hideInitializedLinks();									
//	}
	updateText();
	
	var x = $('#appRef').height();
	var y = $('#devPropInfo').height();
	if(x < y) x = y;
	$('#listDiv').height(x);
	$('#devPropInfo').height(x);

	$('#content').show();
}

function loadDevRef(devRef){
	var trs = listAsDevRef(devRef);
	if(trs){
		$('#appRef').html(trs);
		var sel = getSelectedRow(devRef);
		$('#appRef tr:nth-child('+(++sel)+') a').click();
		//$('#appRef tr:first a').click();
		return true;
	}else{
		return false;
	}	
}

var cu_type, cu_id; 

function selectApp(link, cuType, cuId, devName){
	$('#deviceInformation').text(getRes("ehs.label.device.information") + ' - ' + devName);
	$('a.arrow-link').removeClass('selected');
	link.addClass('selected');
	cu_type=null;
	cu_id=null;
	$('.devRefIcon img').hide();
	link.parent().prev().children().show();
	var x = remote.XGWDeviceAdmin_getDeviceInfo(cuType, cuId);
	if(isError(x)) return;
	var deviceInfo = x.result;
	var trs = devPropInfoAsTr(deviceInfo.DevicePropertyInfo, deviceInfo.IsCoolingDevice);
	trs += getRoomInfo(deviceInfo.RoomInfo);
	$('#devPropInfo').html(trs);
	cu_type=cuType;
	cu_id=cuId;
	last_link = link;
	dev_name = devName;
}

function checkNumbers(event) {
	// Allow only backspace and delete
	if ( event.keyCode == 46 || event.keyCode == 8 ) {
		// let it happen, don't do anything
	}
	else {
		// Ensure that it is a number and stop the keypress
		if (event.keyCode < 48 || event.keyCode > 57 ) {
			event.preventDefault(); 
		}   
	}
}

function getRoomInfo(roomInfo){
	friendly_name = roomInfo.FriendlyName ? roomInfo.FriendlyName : ''; 
	room_name = roomInfo.RoomName ? roomInfo.RoomName : '';
	room_id = roomInfo.RoomID ? roomInfo.RoomID : ''; 
	room_level = roomInfo.RoomLevel ? roomInfo.RoomLevel : ''; 

	var s ='<tr><td class="content" valign="top" height="25px">'+getRes("appSettings.additionalName.value")+'</td>'+
			  '<td align="left" height="25px" valign="top"><input id="friendlyName" type="text" class="inputField roomInfo" value="'+friendly_name+'" /></td></tr>'+
			'<tr><td height="25px" class="content" valign="top">'+getRes("appSettings.roomName.value")+'</td>'+
			    '<td valign="top" height="25px"><input id="roomName" type="text" class="inputField roomInfo" value="'+room_name+'" /></td></tr>' +
			'<tr><td valign="top" height="25px" class="content">'+getRes("appSettings.roomId.value")+'</td> '+
			    '<td valign="top" height="25px"><input id="roomId" type="text" class="inputField roomInfo" onkeydown="return checkNumbers(event)" value="'+ room_id + '" /></td></tr>'+ 
			'<tr><td valign="top" height="25px" class="content">'+getRes("appSettings.roomLevel.value")+'</td>'+
			'<td valign="top" height="25px" ><input id="roomLevel"  type="text" class="inputField roomInfo" value="' + room_level + '" /></td></tr>' +
			'<tr ><td></td><td valign="top" style="padding: 0px 0px 5px 0px;" align="right" >' + 
			      '<button class="link-small-button" onclick="resetRoomInfo()">'+getRes("dialog.cancel.button")+'</button>'+ 
			      '<button class="link-small-button" onclick="updateRoomInfo()" style="margin:5 0 0 5;">'+getRes("dialog.ok.button")+'</button><br/></td></tr>'
		return s;	
    }

function listAsDevRef(list) {
	if (!list) return '';
	var h = '';
	for(var i in list) {
		var cuType = list[i].CUType;
		var cuId = list[i].CUId;
		var devName = list[i].DeviceName;
		var name = list[i].FriendlyName;
		if (!name || name == '') {
			name = devName;
		}else{
			name = devName + ' - ' + name; 
		}
		h += '<tr valign="top" style="height:25px;"><td align="left" valign="top" style="height:25px;">' + 
						'<a class="arrow-link" style="margin: 0 0 0 0;" onclick="selectApp($(this), \''+cuType+'\', \''+cuId +'\', \''+devName +'\');">'
						+ name + '</a>' 
			'</td></tr>';
	}
									
	return h;
}

function getSelectedRow(list) {
	if (!list) return -1;
	if(!cu_type || !cu_id) return 0;
	for(var i in list) {
		var cuType = list[i].CUType;
		var cuId = list[i].CUId;
		if(cuType == cu_type && cu_id == cuId) return i;
	}
	return 0;
}	

function devPropInfoAsTr(list, isCoolingDevice) {
	if (!list) return '';
	var h = ''; for(var i in list) {
		var el = list[i];
		var cuId = el.CUId;
		h += '<tr><td class="content" height="25px" width="40%" align="left" valign="top">'+ el.Name + '</td>';
				var value = el.Value;
				if(value == '') value = getRes('infoservice.not.defined'); /*label must be 'not defined' when the value is "" */
				if(!isCoolingDevice){
				  h += '<td class="content" align="left" valign="top">' + value + '</td></tr>'; 
				} else{
					if(!el.Id){
						h += '<td class="content" align="left" valign="top">' + value  + '</td></tr>';
					}else{
						h += '<td align="left" valign="top">' 
							+ '<input width="100%" class="inputField roomInfo" id="'+el.Id+'" value="'+el.Value+'"></input>' /*input field must be empty when the value is ""*/  
							+ '</td></tr>';
						if (el.Id == "fabricationNumber"){
							fab_num = el.Value;
						} else {
							tech_type = el.Value;
						}
					}	
				}
	}
									
	return h;
}

function updateRoomInfo(){
	if(cu_type && cu_id){
		var res = new Object();
		res.FriendlyName = $('#friendlyName').val();
		res.RoomName = $('#roomName').val();
		res.RoomID = $('#roomId').val();
		res.RoomLevel = $('#roomLevel').val();
		res.FabricationNumber = $('#fabricationNumber').val();
		res.TechnicalType = $('#technicalType').val();
		var x = remote.XGWDeviceAdmin_setDeviceInfo(cu_type, cu_id, res);
		if(isError(x)) {
			resetRoomInfo()
		}else{
//			friendly_name = $('#friendlyName').val();
//			room_name = $('#roomName').val();
//			room_id = $('#roomId').val();
//			room_level = $('#roomLavel').val();
//			fab_num = $('#fabricationNumber').val();
//			tech_type = $('#technicalType').val();
			startEHSPage();
		}
	}
}

function resetRoomInfo(){
	$('#friendlyName').val(friendly_name);
	$('#roomName').val(room_name);
	$('#roomId').val(room_id);
	$('#roomLavel').val(room_level);
	$('#fabricationNumber').val(fab_num);
	$('#technicalType').val(tech_type);

}

function updateAppliancesList() {
    top.showNotProgressBar(getRes("ehs.action.6"), "", top.watingMsg, 60000, reloadApp);
	remote.XGWDeviceAdmin_updateAppliancesList();
}

function factoryReset(){
	top.showConfirmationDialog(getRes("ehs.action.5"),
							   getRes("ehs.confirm.message"), function () {factoryCallback();});
}

function factoryCallback() {
	showFactoryResetProgress(reloadApp);
    remote.XGWDeviceAdmin_restoreFactorySettings();
}

function initialInstalation() {
	showInitialInstalationProgress(refreshPage)
    remote.XGWDeviceAdmin_initialInstallation();
}

function signOnAnotherAppliance() {
    remote.XGWDeviceAdmin_simpleSignOnAppliance();
	distTimer = setTimeout('simpleSignOn();', 30000);
	top.showInfoDialog(getRes("ehs.progress.dialog.title"),
		getRes("initial.wizard.appliances.dist.ha.msg"),
		'info', function () {signOnAnotherAppliance2();}, getRes('initial.wizard.button.next'));

}

function simpleSignOn() {
    remote.XGWDeviceAdmin_simpleSignOnAppliance();
	distTimer = setTimeout('simpleSignOn();', 30000);
}

function signOnAnotherAppliance2() {
	clearTimeout(distTimer);
	showSignOnProgress(refreshPage);
    remote.XGWDeviceAdmin_signOnAppliance();
}

function signOnToMiele() {
	showSignOnToMieleProgress(refreshPage)
    remote.XGWDeviceAdmin_signOnToMiele();
}

function refreshPage(){
	top.setFirstPage();
	//top.setLastPage();
}

function reloadApp() {
	top.location = top.location;
}

//function showInitializedLinks(){
//$('#sign_on').show();
//$('#factory_settings').show();
//$('#initial_settings').hide();
//$('#sign_on_to_miele').hide();
////$('#ehsbodytable').show();
//}
//
//function hideInitializedLinks(){
//$('#sign_on').hide();
//$('#factory_settings').hide();
//$('#initial_settings').show();
//$('#sign_on_to_miele').show();
////$('#ehsbodytable').hide();                   
//}



