function listAsOptions(list) {
	if (!list) return '';
	var h = ''; for(var i in list) h += '<option>' + list[i] + '</option>'; return h;
}


function keyValueListAsOptions(list) {
	if (!list) return '';
	var h = ''; for(var i in list) h += '<option value=' + list[i].Name + '>' + list[i].Value + '</option>'; return h;
}

//function updateText(map, container){
function updateText(map, prefix){
	map = map == null ? resourceMap : map;
	if(resourceMap == null) resourceMap = loadResources(types, resources, "GWAdmin")
	if (!map) return;
	$.each(map, function(key, value){
		//var id = (container == null ? '#' :  container + ' #') + replaceAll(key, '.', '_');
		var id = (prefix == null || prefix.charAt(0) != '#' ? '#' :  prefix) + replaceAll(key, '.', '_');
		$(id).html(value);
	});
}

function getRes(resName){
	return getResource(resourceMap, resName);
}

function getResource(map, resName){
	if (!map) return resName;
	return map[resName];
}

//an utility method. Will pop-up an error dialog if the RPC response is error.
//returns true if the response is error
function isError(x, desc) {
	if (x.error) {
		var e = x.error;
		var message = ('code: '+ e.code +
					  (e.message ? '\nmessage: '+ e.message : '') + 
					  (e.data ? '\ndata: '+ e.data : '') + 
					  (desc ? '\ndescription: '+ desc : ''));
		
		if(e.code == -32000){ //session expired
			top.showLoginDialog();
		}else{
			top.showInfoDialog('Error', message, 'error', null);
		}
//
//		
//		top.showInfoDialog( 'Error',
//							message, 
//							'error',
//							e.code == -32000 && top.showLoginDialog? top.showLoginDialog() : '');
		return true;
	}
	return false;
}


function replaceAll(Source,stringToFind,stringToReplace){
  var temp = Source;
    var index = temp.indexOf(stringToFind);
        while(index != -1){
            temp = temp.replace(stringToFind,stringToReplace);
            index = temp.indexOf(stringToFind);
        }
        return temp;
}


function isChecked(checkBox){
  return checkBox.attr('checked') ? true : false;
}

function check(checkBox, value){
	checkBox.attr('checked', value);
}

/*
 * Load resources and store them into a resourceMap. The resourceMap is used by the updateText to localize resources in the page.
 */
function loadResources(types, resources, app) {
	if(app){ //use application resource cache
		if(!top.cache) top.cache = {};
		if(!top.cache[app]){
			var x = remote.XGWResource_getResources(types, resources);
			top.cache[app] = x.result;
		}	
		 resourceMap = top.cache[app];
	}else{
		var x = remote.XGWResource_getResources(types, resources);
		resourceMap = x.result;
	}
	return resourceMap;
}

/*
 * Get additional resources and return them as a map. They are not store in the resourceMap  
 */
function getResources(types, resources, app) {
	if(app){ //use application resource cache
		if(!top.cache) top.cache = {};
		if(!top.cache[app]){
			var x = remote.XGWResource_getResources(types, resources);
			top.cache[app] = x.result;
		}	
		 return top.cache[app];
	}else{
		var x = remote.XGWResource_getResources(types, resources);
		return x.result;
	}
	return null;
}


function showFactoryResetProgress(callback, remainMs) {
	var tickMs = 1800;
	if(remainMs){
		remainingPercent = Math.round(100 - remainMs / tickMs);
	}
	
	top.showProgressBar(getResource(resourceMap, "ehs.action.5"),
			getResource(resourceMap, "ehs.dialog.factory"), 
			getResource(resourceMap, "reset.modem.all.success"), tickMs, 3000, 'false', callback);

	if(remainMs){
    	progValue = remainingPercent;
    }	
}

function showInitialInstalationProgress(callback, remainMs) {
	var tickMs = 1800;
	if(remainMs){
		remainingPercent = Math.round(100 - remainMs / tickMs);
	}

    top.showProgressBar(getResource(resourceMap, "ehs.action.1"),
    					getResource(resourceMap, "ehs.dialog.initial"), 
    					getResource(resourceMap, "create.house.address.success"), tickMs, 3000, 'false', callback);
	if(remainMs){
    	progValue = remainingPercent;
    }	
}


function showSignOnProgress(callback, remainMs) {
	var tickMs = 1200;
	if(remainMs){
		remainingPercent = Math.round(100 - remainMs / tickMs) ;
	}

    top.showProgressBar(getResource(resourceMap, "ehs.progress.dialog.title"),
    					getResource(resourceMap, "ehs.progress.dialog.loaded"), 
    					getResource(resourceMap, "distribute.house.address.success"), tickMs, 3000, true, callback); //2400
    if(remainMs){
    	progValue = remainingPercent;
    }	
}

function showSignOnToMieleProgress(callback, remainMs) {
	var tickMs = 2400;
	if(remainMs){
		remainingPercent = Math.round(100 - remainMs / tickMs);
	}

    top.showProgressBar(getResource(resourceMap, "ehs.action.2"),
    					getResource(resourceMap, "ehs.progress.dialog.title1"), 
    					getResource(resourceMap, "acquisition.ha.modem.success"), tickMs, 0, false, callback); //2400
	if(remainMs){
    	progValue = remainingPercent;
    }	
}

function checkTime(i){
	if (i<10) {
	  i="0" + i;
	}
	return i;
}


function setEnable(elm, isEnable){
	if(isEnable){
		elm.prop('disabled', null);
	}else{
		elm.attr('disabled', true);
	}
}


function timeAsString(time) {
	var today = new Date(time);
	var h=today.getUTCHours();
	var m=today.getUTCMinutes();
	var s=today.getUTCSeconds();
	var d=checkTime(today.getUTCDate());
	var month=checkTime(today.getUTCMonth() + 1);
	var y=today.getUTCFullYear();
	// add a zero in front of numbers<10
	m=checkTime(m);
	s=checkTime(s);
	return d + '.' + month + '.' + y + ' ' + h + ':' + m + ':' + s;
}

function getColor(tariff) {
	if (tariff == -1) {
		return '#00AAFF';
	} else if (tariff == -2) {
		return '#C0C0C0';
	} else if (tariff == 0) {
		return '#00FF00';
	} else if (tariff == 1) {
		return '#FFFF00';
	} else if (tariff == 2) {
		return '#FF7F00';
	} else if (tariff == 3) {
		return '#FF0000';
	} else if (tariff == 4) {
		return '#AA0080';
	}
	return '#000000';
}

function getHeight(tariff) {
	if (tariff == -1) {
		return 30;
	} else if (tariff == -2) {
		return 30;
	} else if (tariff == 0) {
		return 20;
	} else if (tariff ==1) {
		return 30;
	} else if (tariff == 2) {
		return 40;
	} else if (tariff == 3) {
		return 50;
	} else if (tariff == 4) {
		return 60;
	}
	return 30;
}

function getEditorHeight(tariff) {
	if (tariff == -1) {
		return 60;
	} else if (tariff == -2) {
		return 60;
	} else if (tariff == 0) {
		return 20;
	} else if (tariff ==1) {
		return 30;
	} else if (tariff == 2) {
		return 40;
	} else if (tariff == 3) {
		return 50;
	} else if (tariff == 4) {
		return 60;
	}
	return 40;
}

function clearResourceCache(){
	top.cache = null;
	resourceMap = null;
}